package s;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.net.*;
import java.util.*;

import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.StreamingOutput;

@Path("/")
public class Rj1Serv {
    @GET
    @Path("ping")
    @Produces("application/xml")
    public StreamingOutput ping() {
        String s = "";
        try {
            InetAddress host = InetAddress.getLocalHost();
            s = "Java RESTful " + host.getHostName() +
                " (" + host.getHostAddress() + ":8080), " + new Date();
        } catch (Exception e) {
            s = "ERROR";
        }
        final String res = s + " method GET";
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @GET
    @Path("upcase")
    @Produces("application/xml")
    @Consumes("application/xml")
    public StreamingOutput upcaseQ(@QueryParam("s") String s) {
        final String res = s.toUpperCase() + " method GET";
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @POST
    @Path("upcase/{s}")
    @Produces("application/xml")
    @Consumes("application/xml")
    public StreamingOutput upcaseP(@PathParam("s") String s) {
        final String res = s.toUpperCase() + " method POST";
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @PUT
    @Path("add")
    @Produces("application/xml")
    @Consumes("application/x-www-form-urlencoded")
    public StreamingOutput addF(@FormParam("a") int a, @FormParam("b") int b) {
        final String res = (a + b) + " method PUT";
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    @DELETE
    @Path("add/{a}/{b}")
    @Produces("application/xml")
    @Consumes("application/xml")
    public StreamingOutput addP(@PathParam("a") int a, @PathParam("b") int b) {
        final String res = (a + b) + " method DELETE";
        return new StreamingOutput() {
            public void write(OutputStream output) throws IOException,
                    WebApplicationException {
                writeRasp(output, res);
            }
        };
    }

    protected void writeRasp(OutputStream os, String res) {
        PrintStream writer = new PrintStream(os);
        writer.println(res);
        writer.close();
    }
}
