<?php
require_once ('RestServer.php');
class Rh1Serv implements RestController {
    private $rest;
    public function execute(RestServer $rest) {
        return $rest;
    } // Vida, nefolosita, dar trebuie
    function ping(RestServer $rest) {
        $rest->getResponse()->setResponse("PHP RESTful " . $_SERVER["SERVER_NAME"] . " (" .
                gethostbyname($_SERVER["SERVER_NAME"]) . ":" .
                $_SERVER["SERVER_PORT"] . "), " . date("Y.m.d H:i:s") . " method GET");
        return $rest ;
    }
    function upcaseQ(RestServer $rest) {
        $s = $rest->getRequest()->getGet("s");
        $rest->getResponse()->setResponse(strtoupper($s) . " method GET");
        return $rest ;
    }
    function upcaseP(RestServer $rest) {
        $s = $rest->getRequest()->getURI(3);
        $rest->getResponse()->setResponse(strtoupper($s) . " method POST");
        return $rest ;
    }
    function addQ(RestServer $rest) {
        $s = $rest->getRequest()->getPut();
        $rest->getResponse()->setResponse(($s["a"] + $s["b"]) . " method PUT");
        return $rest ;
    }
    function addP(RestServer $rest) {
        $a = $rest->getRequest()->getURI(3);
        $b = $rest->getRequest()->getURI(4);
        $rest->getResponse()->setResponse(($a + $b) . " method DELETE");
        return $rest ;
    }
    function init() {
        $this->rest = new RestServer();
        $this->rest->addMap("GET",    "/Rh1Serv.php/ping", "Rh1Serv::ping");
        $this->rest->addMap("GET",    "/Rh1Serv.php/upcase\?s=.+", "Rh1Serv::upcaseQ");
        $this->rest->addMap("POST",   "/Rh1Serv.php/upcase/.+", "Rh1Serv::upcaseP");
        $this->rest->addMap("DELETE", "/Rh1Serv.php/add/-?[0-9]+/-?[0-9]+", "Rh1Serv::addP");
        $this->rest->addMap("PUT",    "/Rh1Serv.php/add", "Rh1Serv::addQ");
    }
    function wait() {
        echo $this->rest->execute();
    }
}
$serv = new Rh1Serv();
$serv->init();
$serv->wait();
?>
